#include "CRC_UDM.h"
#include "can.h"
#include "Global_Variable.h"

#define CRC_TABLELENGTH 256u
#define UINT8_MAX ((uint8)0xFF)


/*@!Encoding:949*/


#define CRC8_TABLELENGTH 256u

static const uint8 CRC8_J1850_TABLE[256]=
{
0x00, 0x1D, 0x3A, 0x27, 0x74, 0x69, 0x4E, 0x53,
0xE8, 0xF5, 0xD2, 0xCF, 0x9C, 0x81, 0xA6, 0xBB,
0xCD, 0xD0, 0xF7, 0xEA, 0xB9, 0xA4, 0x83, 0x9E,
0x25, 0x38, 0x1F, 0x02, 0x51, 0x4C, 0x6B, 0x76,
0x87, 0x9A, 0xBD, 0xA0, 0xF3, 0xEE, 0xC9, 0xD4,
0x6F, 0x72, 0x55, 0x48, 0x1B, 0x06, 0x21, 0x3C,
0x4A, 0x57, 0x70, 0x6D, 0x3E, 0x23, 0x04, 0x19,
0xA2, 0xBF, 0x98, 0x85, 0xD6, 0xCB, 0xEC, 0xF1,
0x13, 0x0E, 0x29, 0x34, 0x67, 0x7A, 0x5D, 0x40,
0xFB, 0xE6, 0xC1, 0xDC, 0x8F, 0x92, 0xB5, 0xA8,
0xDE, 0xC3, 0xE4, 0xF9, 0xAA, 0xB7, 0x90, 0x8D,
0x36, 0x2B, 0x0C, 0x11, 0x42, 0x5F, 0x78, 0x65,
0x94, 0x89, 0xAE, 0xB3, 0xE0, 0xFD, 0xDA, 0xC7,
0x7C, 0x61, 0x46, 0x5B, 0x08, 0x15, 0x32, 0x2F,
0x59, 0x44, 0x63, 0x7E, 0x2D, 0x30, 0x17, 0x0A,
0xB1, 0xAC, 0x8B, 0x96, 0xC5, 0xD8, 0xFF, 0xE2,
0x26, 0x3B, 0x1C, 0x01, 0x52, 0x4F, 0x68, 0x75,
0xCE, 0xD3, 0xF4, 0xE9, 0xBA, 0xA7, 0x80, 0x9D,
0xEB, 0xF6, 0xD1, 0xCC, 0x9F, 0x82, 0xA5, 0xB8,
0x03, 0x1E, 0x39, 0x24, 0x77, 0x6A, 0x4D, 0x50,
0xA1, 0xBC, 0x9B, 0x86, 0xD5, 0xC8, 0xEF, 0xF2,
0x49, 0x54, 0x73, 0x6E, 0x3D, 0x20, 0x07, 0x1A,
0x6C, 0x71, 0x56, 0x4B, 0x18, 0x05, 0x22, 0x3F,
0x84, 0x99, 0xBE, 0xA3, 0xF0, 0xED, 0xCA, 0xD7,
0x35, 0x28, 0x0F, 0x12, 0x41, 0x5C, 0x7B, 0x66,
0xDD, 0xC0, 0xE7, 0xFA, 0xA9, 0xB4, 0x93, 0x8E,
0xF8, 0xE5, 0xC2, 0xDF, 0x8C, 0x91, 0xB6, 0xAB,
0x10, 0x0D, 0x2A, 0x37, 0x64, 0x79, 0x5E, 0x43,
0xB2, 0xAF, 0x88, 0x95, 0xC6, 0xDB, 0xFC, 0xE1,
0x5A, 0x47, 0x60, 0x7D, 0x2E, 0x33, 0x14, 0x09,
0x7F, 0x62, 0x45, 0x58, 0x0B, 0x16, 0x31, 0x2C,
0x97, 0x8A, 0xAD, 0xB0, 0xE3, 0xFE, 0xD9, 0xC4
};

// �뼹�씪�씠釉� 移댁슫�꽣
int PublicTimer_4BIT(int T)
{
  if (T<16)
  {
    T++;
  }
  else
  {
    T= 0;
  }
  return T;
}

unsigned long crclib_getCRC8_4BIT(const uint8 *xData, uint16 xDatalen)
{

	uint8 CRC1;
	uint8 CRC2;
	uint8 idx;
	uint8 crc = UINT8_MAX;

	for(idx=0; idx < xDatalen ; idx++){

		crc =CRC8_J1850_TABLE[crc ^(xData[idx])];

	}
	crc^=UINT8_MAX;

	CRC1 = (crc >> shift0) & _4bit;
	CRC2 = (crc >> shift4) & _4bit;


	crc = CRC1^CRC2;

	return crc;

}

unsigned long Proxy_CalChksm_IDB_BrakeEcuStatus_CAN_4BIT(unsigned char data[])
{

	uint8 CalcChecksum;
	CalcChecksum = crclib_getCRC8_4BIT(&data[1],7);
	return CalcChecksum;
}




#if 1


// ========================== ACU 들어가는 4비트 CRC, ALV========================================
unsigned long CRC8_Func_FOR_ACU_4BIT(long aId, int xDatalen, unsigned char data[])
{
  unsigned long ret = 1;
  int CrcDlc = xDatalen - 2;
  unsigned short DataId = aId;
  unsigned short WrongDataId; /* Edited(Oct 05th, 2018)*/

  if(aId == 0x570)
  {
		ECU3.TX.CH1_BCM_VCU_ACU_Signal1_0x570.BCM_VCU_counter1 = PublicTimer_4BIT(ECU3.TX.CH1_BCM_VCU_ACU_Signal1_0x570.BCM_VCU_counter1);

		GV_ACU_BCM_VCU_counter1 = ECU3.TX.CH1_BCM_VCU_ACU_Signal1_0x570.BCM_VCU_counter1;

		ECU3.TX.CH1_BCM_VCU_ACU_Signal1_0x570.BCM_VCU_CRC1= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN_4BIT(data);

	    GV_ACU_BCM_VCU_CRC1 = ECU3.TX.CH1_BCM_VCU_ACU_Signal1_0x570.BCM_VCU_CRC1;
  }

  if(aId == 0x580)
  {
		ECU3.TX.CH1_BCM_VCU_ACU_Signal2_0x580.BCM_VCU_counter2 = PublicTimer_4BIT(ECU3.TX.CH1_BCM_VCU_ACU_Signal2_0x580.BCM_VCU_counter2);

		GV_BCM_VCU_counter2 = ECU3.TX.CH1_BCM_VCU_ACU_Signal2_0x580.BCM_VCU_counter2;

		ECU3.TX.CH1_BCM_VCU_ACU_Signal2_0x580.BCM_VCU_CRC2= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN_4BIT(data);

	    GV_BCM_VCU_CRC2 = ECU3.TX.CH1_BCM_VCU_ACU_Signal2_0x580.BCM_VCU_CRC2;
  }

  if(aId == 0x590)
  {
		ECU3.TX.CH1_BCM_VCU_ACU_Signal3_0x590.BCM_VCU_counter3 = PublicTimer_4BIT(ECU3.TX.CH1_BCM_VCU_ACU_Signal3_0x590.BCM_VCU_counter3);

		GV_BCM_VCU_counter3 = ECU3.TX.CH1_BCM_VCU_ACU_Signal3_0x590.BCM_VCU_counter3;

		ECU3.TX.CH1_BCM_VCU_ACU_Signal3_0x590.BCM_VCU_CRC3= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN_4BIT(data);

		GV_BCM_VCU_CRC3 = ECU3.TX.CH1_BCM_VCU_ACU_Signal3_0x590.BCM_VCU_CRC3;
  }


  if(aId == 0x595)
  {
		ECU3.TX.CH1_BCM_VCU_ACU_Signal4_0x595.BCM_VCU_counter4 = PublicTimer_4BIT(ECU3.TX.CH1_BCM_VCU_ACU_Signal4_0x595.BCM_VCU_counter4);

		GV_BCM_VCU_counter4 = ECU3.TX.CH1_BCM_VCU_ACU_Signal4_0x595.BCM_VCU_counter4;

		ECU3.TX.CH1_BCM_VCU_ACU_Signal4_0x595.BCM_VCU_CRC4= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN_4BIT(data);

	    GV_BCM_VCU_CRC4 = ECU3.TX.CH1_BCM_VCU_ACU_Signal4_0x595.BCM_VCU_CRC4;
  }

  if(aId == 0x585)
  {
		ECU3.TX.CH1_BCM_VCU_ACU_Signal5_0x585.BCM_VCU_counter5 = PublicTimer_4BIT(ECU3.TX.CH1_BCM_VCU_ACU_Signal5_0x585.BCM_VCU_counter5);

		GV_ACU_BCM_VCU_counter5 = ECU3.TX.CH1_BCM_VCU_ACU_Signal5_0x585.BCM_VCU_counter5;

		ECU3.TX.CH1_BCM_VCU_ACU_Signal5_0x585.BCM_VCU_CRC5= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN_4BIT(data);

	    GV_ACU_BCM_VCU_CRC5 = ECU3.TX.CH1_BCM_VCU_ACU_Signal5_0x585.BCM_VCU_CRC5;
  }

  if(aId == 0x050)
  {
		ECU3.TX.CH1_RWA_VCU_ACU_Signal1_0x050.RWA_VCU_ACU_counter1 = PublicTimer_4BIT(ECU3.TX.CH1_RWA_VCU_ACU_Signal1_0x050.RWA_VCU_ACU_counter1);

		GV_RWA_VCU_ACU_counter1 = ECU3.TX.CH1_RWA_VCU_ACU_Signal1_0x050.RWA_VCU_ACU_counter1;

		ECU3.TX.CH1_RWA_VCU_ACU_Signal1_0x050.RWA_VCU_ACU_CRC1= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN_4BIT(data);

	    GV_RWA_VCU_ACU_CRC1 = ECU3.TX.CH1_RWA_VCU_ACU_Signal1_0x050.RWA_VCU_ACU_CRC1;
  }

  if(aId == 0x051)
  {
		ECU3.TX.CH1_RWA_VCU_ACU_Signal2_0x051.RWA_VCU_ACU_counter2 = PublicTimer_4BIT(ECU3.TX.CH1_RWA_VCU_ACU_Signal2_0x051.RWA_VCU_ACU_counter2);

		GV_RWA_VCU_ACU_counter2 = ECU3.TX.CH1_RWA_VCU_ACU_Signal2_0x051.RWA_VCU_ACU_counter2;

		ECU3.TX.CH1_RWA_VCU_ACU_Signal2_0x051.RWA_VCU_ACU_CRC2= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN_4BIT(data);

	    GV_RWA_VCU_ACU_CRC2 = ECU3.TX.CH1_RWA_VCU_ACU_Signal2_0x051.RWA_VCU_ACU_CRC2;
  }

  if(aId == 0x060)
  {
		ECU3.TX.CH1_RWS_VCU_ACU_Signal1_0x060.RWS_VCU_ACU_counter1 = PublicTimer_4BIT(ECU3.TX.CH1_RWS_VCU_ACU_Signal1_0x060.RWS_VCU_ACU_counter1);

		GV_RWS_VCU_ACU_counter1 = ECU3.TX.CH1_RWS_VCU_ACU_Signal1_0x060.RWS_VCU_ACU_counter1;

		ECU3.TX.CH1_RWS_VCU_ACU_Signal1_0x060.RWS_VCU_ACU_CRC1= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN_4BIT(data);

	    GV_RWS_VCU_ACU_CRC1 = ECU3.TX.CH1_RWS_VCU_ACU_Signal1_0x060.RWS_VCU_ACU_CRC1;
  }

  if(aId == 0x061)
  {
		ECU3.TX.CH1_RWS_VCU_ACU_Signal2_0x061.RWS_VCU_ACU_counter2 = PublicTimer_4BIT(ECU3.TX.CH1_RWS_VCU_ACU_Signal2_0x061.RWS_VCU_ACU_counter2);

		GV_RWS_VCU_ACU_counter2 = ECU3.TX.CH1_RWS_VCU_ACU_Signal2_0x061.RWS_VCU_ACU_counter2;

		ECU3.TX.CH1_RWS_VCU_ACU_Signal2_0x061.RWS_VCU_ACU_CRC2= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN_4BIT(data);

	    GV_RWS_VCU_ACU_CRC2 = ECU3.TX.CH1_RWS_VCU_ACU_Signal2_0x061.RWS_VCU_ACU_CRC2;
  }

  if(aId == 0x013)
  {
		ECU3.TX.CH1_VCU_ACU_Signal1_0x013.VCU_ACU_ARC1 = PublicTimer_4BIT(ECU3.TX.CH1_VCU_ACU_Signal1_0x013.VCU_ACU_ARC1);

		GV_VCU_ACU_ARC1 = ECU3.TX.CH1_VCU_ACU_Signal1_0x013.VCU_ACU_ARC1;

		ECU3.TX.CH1_VCU_ACU_Signal1_0x013.VCU_ACU_CRC1= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN_4BIT(data);

	    GV_VCU_ACU_CRC1 = ECU3.TX.CH1_VCU_ACU_Signal1_0x013.VCU_ACU_CRC1;
  }

  if(aId == 0x014)
  {
		ECU3.TX.CH1_VCU_ACU_Signal2_0x014.VCU_ACU_counter2 = PublicTimer_4BIT(ECU3.TX.CH1_VCU_ACU_Signal2_0x014.VCU_ACU_counter2);

		GV_VCU_ACU_counter2 = ECU3.TX.CH1_VCU_ACU_Signal2_0x014.VCU_ACU_counter2;

		ECU3.TX.CH1_VCU_ACU_Signal2_0x014.VCU_ACU_CRC2= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN_4BIT(data);

	    GV_VCU_ACU_CRC2 = ECU3.TX.CH1_VCU_ACU_Signal2_0x014.VCU_ACU_CRC2;
  }

  if(aId == 0x015)
  {
		ECU3.TX.CH1_VCU_ACU_Signal3_0x015.VCU_ACU_counter3 = PublicTimer_4BIT(ECU3.TX.CH1_VCU_ACU_Signal3_0x015.VCU_ACU_counter3);


		GV_ACU_VCU_ACU_counter3 = ECU3.TX.CH1_VCU_ACU_Signal3_0x015.VCU_ACU_counter3;

		ECU3.TX.CH1_VCU_ACU_Signal3_0x015.VCU_ACU_CRC3= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN_4BIT(data);

	    GV_ACU_VCU_ACU_CRC3 = ECU3.TX.CH1_VCU_ACU_Signal3_0x015.VCU_ACU_CRC3;
  }


  if(aId == 0x016)
  {
		ECU3.TX.CH1_ACU_CAR_STAT_CH1_0x016.ACU_CAR_ARC = PublicTimer_4BIT(ECU3.TX.CH1_ACU_CAR_STAT_CH1_0x016.ACU_CAR_ARC);

		GV_ACU_CAR_ARC = ECU3.TX.CH1_ACU_CAR_STAT_CH1_0x016.ACU_CAR_ARC;

		ECU3.TX.CH1_ACU_CAR_STAT_CH1_0x016.ACU_CAR_CRC= Proxy_CalChksm_IDB_BrakeEcuStatus_CAN_4BIT(data);

	    GV_ACU_CAR_CRC = ECU3.TX.CH1_ACU_CAR_STAT_CH1_0x016.ACU_CAR_CRC;
  }



  return ret;
}




#endif
